Smart.Editor Videos

Editor for React

React version of this topic (compatible with React 19+). Keep the same configuration logic from JavaScript and pass it as component props.

What this topic covers: practical setup, the framework-specific API access pattern, and copy-adapt guidance for the examples in this page.

import React, { useMemo, useRef } from 'react';
import { Editor } from 'smart-webcomponents-react/editor';
import 'smart-webcomponents-react/source/styles/smart.default.css';

export default function App() {
  const componentRef = useRef(null);
  const componentProps = useMemo(() => ({
    // Copy this topic's JavaScript configuration here.
  }), []);

  return <Editor ref={componentRef} {...componentProps}></Editor>;
}

Use componentRef.current for API methods in this topic.

Editor Videos

Smart.Editor can contain videos as well as images, tables and hyperlinks. Videos can be uploaded from local storage or YouTube embed.

YouTube embeded videos use iframes in order to be played via the YouTube player while videos uploaded from local storage use the native HTML5 video tag player.

Videos inserted via the Editor's toolbar can be resized dynamically. Local storage videos can even be dragged. However if the video is not inserted via the Editor it will still be rendered but it will lack those features.

We are going to take a furtuher look into Smart.Editor videos and how to use them in the next section.

Editor Videos Inserting

To insert a video in the Smart.Editor first you need to have the video toolbar item as part of the toolbarItems property. It is enabled by default.

Then:

  1. From the Editor Toolbar click on the video item positioned next to the image item:

    Demo

  2. An Editor Dialog will appear with several fields and controls:

    • A Smart.FileUploader element which allows to upload a video file from local storage. If the user prefers to reference a YouTube video instead then this field should be left blank.
    • A Smart.Input element which allows to enter the url to a YouTube embed video if a local file is not uploaded in the previous control. Links to embeded YouTube videos are obtained from their official website.
    • A Smart.Input field that allows to enter the width for the video. By default a 480px is preset for the width since that is the recommended value for a video by YouTube to mantain the 16:9 ratio aspect.
    • A Smart.Input element that allows to enter the height for the video. By default 270px is preset for the height.
    • A Smart.Input element that allows to set the title for the video. The title will appear when the video is hovered.
    • A Smart.Input element that allows to set the caption for the video. The caption is displayed below the video and can be modified later.
    • A Smart.Input element that allows to set the display and alignment settings for the video. It can be positioned as inline or block element and can be aligned to the left/right or center.
    • A Smart.Checbox that allows to configure whether the video is resizale/draggable or not.

      Note:

      Videos can be resized/dragged only if they are inserted via the Editor Dialog.

      YouTube videos cannot be dragged while videos uploaded from local storage can.

    Here's what the Editor video dialog looks like:

  3. Clicking on the OK button will submit the dialog and create the video inside the Editor.

Once the video is properly configured it will appear as follows:

The Menu icon that is visible in the image above represents a button that appears when the video is hovered. It is not displayed by default to not interfere with the video playback.

The video menu button can be interacted with:

  • Left mouse click on the menu button will select the video and set a resize frame around it (if resizing is not disabled for the video). The resize frame allows to resize the video dynamically from one of the handles.

    The video can be dragged after it has been selected (by clicking on the menu button). This works only for non YouTube videos since they use an iframe element. You can begin dragging the video from the video itself (not from the menu button or the resize handles) and you can drop it anywhere inside the Editor.

    Here's an example drag and drop of a video uploaded from local storage:

  • Right mouse click on the video menu button triggers the context menu for Editor videos. The context menu allows quick actions to be executed. For example:
    • Edit the video from the Video Properties context menu item.
    • Copy the video.
    • Cut the video.
    • Delete the video.
    • Insert/Remove the caption of the video.

    The context menu items can be customized via the contextMenuDataSource property. It is possible to add additional or modify the existing menu items.

Smart.Editor videos can be copied/cut and pasted once the video is selected by clicking on the menu button inside it.

For AI tooling

Developer Quick Reference

Topic: editor-videos   Component: Editor   Framework: React

Main methods: (none detected)

Common config keys: (none detected)

Implementation Notes

Compatibility: React 19+   API access pattern: const componentRef = useRef(null) + componentRef.current.method()

Lifecycle guidance: Use useMemo for large config objects and call imperative API through componentRef.current after first render.

Common pitfalls:

  • Recreating columns/dataSource objects on every render can reset component state.
  • Calling API methods before ref is available causes runtime errors.
  • Mixing controlled and imperative updates without sync can lead to stale UI.

Validation checklist:

  • Keep config objects memoized when possible.
  • Guard API calls with ref existence checks.
  • Verify CSS theme import is present once per app.

Smart.Editor Videos

Editor for Vue

Vue 3 version using Smart custom elements and template refs.

What this topic covers: practical setup, the framework-specific API access pattern, and copy-adapt guidance for the examples in this page.

<script setup>
import { onMounted, ref } from 'vue';
import 'smart-webcomponents/source/styles/smart.default.css';
import 'smart-webcomponents/source/modules/smart.editor.js';

const component = ref();
const componentProps = {
  // Copy this topic's JavaScript configuration here.
};

onMounted(() => {
  Object.assign(component.value, componentProps);
});
</script>

<template>
  <smart-editor ref="component"></smart-editor>
</template>

Use component.value for API methods in this topic.

Editor Videos

Smart.Editor can contain videos as well as images, tables and hyperlinks. Videos can be uploaded from local storage or YouTube embed.

YouTube embeded videos use iframes in order to be played via the YouTube player while videos uploaded from local storage use the native HTML5 video tag player.

Videos inserted via the Editor's toolbar can be resized dynamically. Local storage videos can even be dragged. However if the video is not inserted via the Editor it will still be rendered but it will lack those features.

We are going to take a furtuher look into Smart.Editor videos and how to use them in the next section.

Editor Videos Inserting

To insert a video in the Smart.Editor first you need to have the video toolbar item as part of the toolbarItems property. It is enabled by default.

Then:

  1. From the Editor Toolbar click on the video item positioned next to the image item:

    Demo

  2. An Editor Dialog will appear with several fields and controls:

    • A Smart.FileUploader element which allows to upload a video file from local storage. If the user prefers to reference a YouTube video instead then this field should be left blank.
    • A Smart.Input element which allows to enter the url to a YouTube embed video if a local file is not uploaded in the previous control. Links to embeded YouTube videos are obtained from their official website.
    • A Smart.Input field that allows to enter the width for the video. By default a 480px is preset for the width since that is the recommended value for a video by YouTube to mantain the 16:9 ratio aspect.
    • A Smart.Input element that allows to enter the height for the video. By default 270px is preset for the height.
    • A Smart.Input element that allows to set the title for the video. The title will appear when the video is hovered.
    • A Smart.Input element that allows to set the caption for the video. The caption is displayed below the video and can be modified later.
    • A Smart.Input element that allows to set the display and alignment settings for the video. It can be positioned as inline or block element and can be aligned to the left/right or center.
    • A Smart.Checbox that allows to configure whether the video is resizale/draggable or not.

      Note:

      Videos can be resized/dragged only if they are inserted via the Editor Dialog.

      YouTube videos cannot be dragged while videos uploaded from local storage can.

    Here's what the Editor video dialog looks like:

  3. Clicking on the OK button will submit the dialog and create the video inside the Editor.

Once the video is properly configured it will appear as follows:

The Menu icon that is visible in the image above represents a button that appears when the video is hovered. It is not displayed by default to not interfere with the video playback.

The video menu button can be interacted with:

  • Left mouse click on the menu button will select the video and set a resize frame around it (if resizing is not disabled for the video). The resize frame allows to resize the video dynamically from one of the handles.

    The video can be dragged after it has been selected (by clicking on the menu button). This works only for non YouTube videos since they use an iframe element. You can begin dragging the video from the video itself (not from the menu button or the resize handles) and you can drop it anywhere inside the Editor.

    Here's an example drag and drop of a video uploaded from local storage:

  • Right mouse click on the video menu button triggers the context menu for Editor videos. The context menu allows quick actions to be executed. For example:
    • Edit the video from the Video Properties context menu item.
    • Copy the video.
    • Cut the video.
    • Delete the video.
    • Insert/Remove the caption of the video.

    The context menu items can be customized via the contextMenuDataSource property. It is possible to add additional or modify the existing menu items.

Smart.Editor videos can be copied/cut and pasted once the video is selected by clicking on the menu button inside it.

For AI tooling

Developer Quick Reference

Topic: editor-videos   Component: Editor   Framework: Vue

Main methods: (none detected)

Common config keys: (none detected)

Implementation Notes

Compatibility: Vue 3+   API access pattern: const component = ref() + component.value.method()

Lifecycle guidance: Use template refs with

Smart.Editor Videos

Editor for Angular

Angular standalone version of this topic (compatible with Angular 17+). Import both the Smart UI component and module in the standalone component.

What this topic covers: practical setup, the framework-specific API access pattern, and copy-adapt guidance for the examples in this page.

import { Component, ViewChild, ViewEncapsulation } from '@angular/core';
import { CommonModule } from '@angular/common';
import { RouterOutlet } from '@angular/router';
import { EditorComponent, EditorModule } from 'smart-webcomponents-angular/editor';

@Component({
  selector: 'app-root',
  standalone: true,
  imports: [CommonModule, EditorModule, RouterOutlet],
  templateUrl: './app.component.html',
  styleUrls: ['./app.component.css'],
  encapsulation: ViewEncapsulation.None
})
export class AppComponent {
  @ViewChild('editor', { read: EditorComponent, static: false }) editor!: EditorComponent;
}
<!-- app.component.html -->
<smart-editor #editor></smart-editor>

Use this.editor for API methods in this topic.

Editor Videos

Smart.Editor can contain videos as well as images, tables and hyperlinks. Videos can be uploaded from local storage or YouTube embed.

YouTube embeded videos use iframes in order to be played via the YouTube player while videos uploaded from local storage use the native HTML5 video tag player.

Videos inserted via the Editor's toolbar can be resized dynamically. Local storage videos can even be dragged. However if the video is not inserted via the Editor it will still be rendered but it will lack those features.

We are going to take a furtuher look into Smart.Editor videos and how to use them in the next section.

Editor Videos Inserting

To insert a video in the Smart.Editor first you need to have the video toolbar item as part of the toolbarItems property. It is enabled by default.

Then:

  1. From the Editor Toolbar click on the video item positioned next to the image item:

    Demo

  2. An Editor Dialog will appear with several fields and controls:

    • A Smart.FileUploader element which allows to upload a video file from local storage. If the user prefers to reference a YouTube video instead then this field should be left blank.
    • A Smart.Input element which allows to enter the url to a YouTube embed video if a local file is not uploaded in the previous control. Links to embeded YouTube videos are obtained from their official website.
    • A Smart.Input field that allows to enter the width for the video. By default a 480px is preset for the width since that is the recommended value for a video by YouTube to mantain the 16:9 ratio aspect.
    • A Smart.Input element that allows to enter the height for the video. By default 270px is preset for the height.
    • A Smart.Input element that allows to set the title for the video. The title will appear when the video is hovered.
    • A Smart.Input element that allows to set the caption for the video. The caption is displayed below the video and can be modified later.
    • A Smart.Input element that allows to set the display and alignment settings for the video. It can be positioned as inline or block element and can be aligned to the left/right or center.
    • A Smart.Checbox that allows to configure whether the video is resizale/draggable or not.

      Note:

      Videos can be resized/dragged only if they are inserted via the Editor Dialog.

      YouTube videos cannot be dragged while videos uploaded from local storage can.

    Here's what the Editor video dialog looks like:

  3. Clicking on the OK button will submit the dialog and create the video inside the Editor.

Once the video is properly configured it will appear as follows:

The Menu icon that is visible in the image above represents a button that appears when the video is hovered. It is not displayed by default to not interfere with the video playback.

The video menu button can be interacted with:

  • Left mouse click on the menu button will select the video and set a resize frame around it (if resizing is not disabled for the video). The resize frame allows to resize the video dynamically from one of the handles.

    The video can be dragged after it has been selected (by clicking on the menu button). This works only for non YouTube videos since they use an iframe element. You can begin dragging the video from the video itself (not from the menu button or the resize handles) and you can drop it anywhere inside the Editor.

    Here's an example drag and drop of a video uploaded from local storage:

  • Right mouse click on the video menu button triggers the context menu for Editor videos. The context menu allows quick actions to be executed. For example:
    • Edit the video from the Video Properties context menu item.
    • Copy the video.
    • Cut the video.
    • Delete the video.
    • Insert/Remove the caption of the video.

    The context menu items can be customized via the contextMenuDataSource property. It is possible to add additional or modify the existing menu items.

Smart.Editor videos can be copied/cut and pasted once the video is selected by clicking on the menu button inside it.

For AI tooling

Developer Quick Reference

Topic: editor-videos   Component: Editor   Framework: Angular

Main methods: (none detected)

Common config keys: (none detected)

Implementation Notes

Compatibility: Angular 17+ (standalone)   API access pattern: @ViewChild(...) + this.component.method()

Lifecycle guidance: Bind inputs declaratively and call imperative API through @ViewChild in/after ngAfterViewInit.

Common pitfalls:

  • Using @ViewChild API too early (before view init).
  • Omitting standalone imports for Smart modules in @Component.imports.
  • Type mismatches between configuration fields and template bindings.

Validation checklist:

  • Ensure module import exists in standalone component imports array.
  • Use typed @ViewChild(..., { read: ComponentType }).
  • Call imperative methods after view initialization.